' EncodeScriptEx.VBS V1.00 (C) yoshioka.teruo@nifty.com 2005-07-12
' EncodeScriptEx.VBS encodes script including Japanese text.
' Usage: Start EncodeScriptEx.VBS files...

Option Explicit

Dim fso
Dim Encoder
Dim arg
Dim File
Dim iPath
Dim iName
Dim FolderName
Dim BaseName
Dim ExtensionName
Dim Ext
Dim Language
Dim Source
Dim Code
Dim oName
Dim oPath
Dim BackUp
Dim k
Dim fName

Set fso=CreateObject("Scripting.FileSystemObject")
Set Encoder=CreateObject("Scripting.Encoder")

For Each arg In WScript.Arguments
  Set File=fso.GetFile(arg)
  iPath=File.Path
  iName=File.Name
  FolderName=fso.GetParentFolderName(iPath)
  BaseName=fso.GetBaseName(iName)
  ExtensionName=fso.GetExtensionName(iName)
  Source=fso.OpenTextFile(iPath).ReadAll()
  Select Case(LCase(ExtensionName))
  Case "vbs"
    Language="VBScript"
    Ext=".VBE"
    Code=Encoder.EncodeScriptFile(".VBS","Execute(UnEscape("""&Escape(Source)&""")):",0,Empty)
  Case "js"
    Language="JScript"
    Ext=".JSE"
    Code=Encoder.EncodeScriptFile(".JS","eval(unescape("""&Escape(Source)&"""));",0,Empty)
  Case "pls"
    Language="PerlScript"
    Ext=".VBE"
    Code=Encoder.EncodeScriptFile(".VBS","Set SC=CreateObject(""ScriptControl""):SC.Language="""&Language&""":SC.AllowUI=true:SC.TimeOut=-1:SC.AddObject ""WScript"",WScript,True:On Error Resume Next:SC.ExecuteStatement(UnEscape("""&Escape(Source)&""")):If Err Then WScript.Echo Join(Array(""Script:""&vbTab&WScript.ScriptFullname,""Number:""&vbTab&SC.Error.Number,""Description:""&vbTab&SC.Error.Description,""Source:""&vbTab&SC.Error.Source,""Text:""&vbTab&SC.Error.Text,""Line:""&vbTab&SC.Error.Line,""Column:""&vbTab&SC.Error.Column),vbLf)",0,Empty)
  Case Else
    Language=ExtensionName
    Ext="."&ExtensionName&".Encode"
    Code=Encoder.EncodeScriptFile(".JS","execScript(unescape("""&Escape(Source)&"""),"""&Language&""");",0,Empty)
  End Select
  Code=Replace(Code,vbNullChar,"")
  oName=BaseName&Ext
  oPath=fso.BuildPath(FolderName,oName)
  BackUp=""
  If fso.FileExists(oPath) Then
    Set File=fso.GetFile(oPath)
    For k=1000 To 1999
      fName=BaseName & "." & Right(k ,3)
      Call Rename(File,fName)
      If Err=0 Then
        Exit For
      ElseIf Err<>58 Then
        WScript.Echo Err.Number & " : " & Err.Description
        WSscript.Quit
      End If
    Next
    BackUp=vbLf & "BackUp" & vbTab & fName
  End If
  fso.CreateTextFile(oPath,False).Write Code
  WScript.Echo "Script Encoded." & vbLf _
             & "To" & vbTab & oName & vbLf _
             & "From" & vbTab & iName & Backup
Next
WScript.Quit

Sub Rename(File,Name)
On Error Resume Next
File.Name=Name
End Sub
